#pragma once

#include <iostream>
#include <fstream>
#include <string>

#include "Node.hpp"

using std::cin;
using std::cout;
using std::endl;

using std::ifstream;
using std::ofstream;
using std::fstream;

using std::string;

template <class T>
class BST
{
public:
	void insert(T &newData); 

private:
	Node<T>* mpRoot;

	// we're using the private version of insert to allow for procedural
	// abstraction for the public interface; we don't want to show
	// that we're using pointers for our design; someone using our
	// template doesn't need to know specifically how the tree was developed, just
	// that to insert you need to specify the data
	void insert(Node<T>* pTree, T& newData);
};

template<class T>
inline void BST<T>::insert(T& newData)
{
	insert(this->mpRoot, newData);
}

template<class T>
inline void BST<T>::insert(Node<T>* pTree, T& newData)
{
	// Node<T>* pMem = new Node (newData);
	if (pTree == nullptr)
	{
		// tree must be empty
		this->mpRoot = new Node<T>(newData);
	}
	else
	{
		// recursion
		//if (pTree->getData()) // we'll finish on Mon, Mar 4
		//{

		//}
	}
}
