#pragma once

#include <iostream>
#include <fstream>
#include <string>

using std::cin;
using std::cout;
using std::endl;

using std::ifstream;
using std::ofstream;
using std::fstream;

using std::string;

template <class T>
class Node
{
public:
	Node(T& newData);

	T getData() const;

private: 
	T mData;
	Node<T>* mpLeft, 
		   * mpRight;
};

template<class T>
Node<T>::Node(T& newData)
{
	this->mData = newData;
	this->mpLeft = this->mpRight = nullptr;
}

template <class T>
T Node<T>::getData() const
{
	return this->mData;
}